<?php require_once('connectdb.php'); ?>
<?php

	// For debug
	$saveUpdatePacket = false;
	// $saveUpdatePacket = true;

	// ----- Functions -----
	function formatString($str) {
		$str = utf8_decode($str); 
    	return "'".mysql_escape_string($str)."'";
    }
    
    // ----- NO CACHE -----
 	session_cache_limiter('nocache');
   
 	header("Expires: Thu, 19 Nov 1981 08:52:00 GMT");
 	/* For HTTP/1.1 conforming clients and the rest (MSIE 5) */
 	header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
 	/* For HTTP/1.0 conforming clients */
	header("Pragma: no-cache");	
	
	// ----- MySQL Connection -----
	mysql_select_db($database_db, $connect_db);	
    
	// ----- Read XML -----	
	$xml = "";
	$dom = new DOMDocument();
	
	if (isset($debug) && $debug == "1") {
		$dom->load("updatePacket.xml");
	} else {
		$xml = file_get_contents("php://input");

		if ($xml == "") {
			die("WAIT AN UPDATE PACKET");
		}
		$dom->loadXML($xml);
	}
	
	$doc = $dom->documentElement;
	
	if ($saveUpdatePacket) {
		$fp = fopen("updatePacket.xml", "w");
		fwrite($fp, $dom->saveXML());
		fclose($fp);
	}
	
	// rootNode
	$rootNode = $dom->documentElement;
	
	$tableName = $rootNode->getAttribute("tableName");
	$transID = $rootNode->getAttribute("transID");
	$nullValue = $rootNode->getAttribute("nullValue");
	
	// -- Null Value --
	$lastChar = strlen($nullValue)-1;
 	if (strpos($nullValue, "{") == 0 && strpos($nullValue, "}") == $lastChar) {
 		$nullValue = substr($nullValue, 1, $lastChar-1);
	}
	
	// ----- Prepare resultDoc -----
	$resultdoc = new DOMDocument();
	$resultdoc->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><update_packet></update_packet>");

	$resultRootNode = $resultdoc->documentElement;
	$resultRootNode->setAttribute("transID", $transID);
	
	// ----- process "update" nodes -----	
	$nodes = $dom->getElementsByTagName("update");
	foreach ($nodes as $node) {
		$operationId = $node->getAttribute("id");
		$fields = $node->getElementsByTagName("field");
		// -- find key --
		foreach ($fields as $field) {
			if ($field->getAttribute("key") == "true") {
				$kname = $field->getAttribute("name");
				$ktype = $field->getAttribute("type");
				$kvalue = $field->getAttribute("oldValue");
				$stmt = $kvalue;
				if ($ktype == "Integer" || $ktype == "Number") {
					$stmt = $kname . "=" . $kvalue;
				} else {
					$stmt = $kname . "= " . formatString($kvalue);
				}
				break;
			}
		}
		
		$condStmt = $stmt;
		$strSQL = "SELECT * FROM " . $tableName . " WHERE " . $stmt;
		$recordset = mysql_query($strSQL);
		$numRows = mysql_num_rows($recordset);
		mysql_free_result($recordset);
		
		if ($numRows == 0) {
			// Cas record supprim
		} else {
			$updateStmt = "";
			// -- update record --
			foreach ($fields as $field) {
				if ($field->getAttribute("key") == "false") {
					$fname = $field->getAttribute("name");
					$ftype = $field->getAttribute("type");
					$fvalue = $field->getAttribute("newValue");
					// -- check NullValue --
					if ($fvalue == $nullValue) {
						$fvalue = "NULL";
					}
					// -- format value --
					if ($ftype == "Integer" || $ftype == "Number") {
						$stmt = $fname . "=" . $fvalue;
					} else {
						$stmt = $fname . "= " . formatString($fvalue);
					}
					
					if ($updateStmt == "") {
						$updateStmt = $stmt;
					} else {
						$updateStmt = $updateStmt . ", " . $stmt;
					}
				}
			}
			// Build update Statement
			$strSQL = "UPDATE " . $tableName . " SET " .  $updateStmt . " WHERE " . $condStmt; 
			$recordset = mysql_query($strSQL);
			
		}
	}
		
		
	// ----- process "delete" nodes -----	
	$nodes = $dom->getElementsByTagName("delete");
	foreach ($nodes as $node) {
		$operationId = $node->getAttribute("id");
		$fields = $node->getElementsByTagName("field");
		// -- find key --
		foreach ($fields as $field) {
			if ($field->getAttribute("key") == "true") {
				$kname = $field->getAttribute("name");
				$ktype = $field->getAttribute("type");
				$kvalue = $field->getAttribute("oldValue");
				$stmt = $kvalue;
				if ($ktype == "Integer" || $ktype == "Number") {
					$stmt = $kname . "=" . $kvalue;
				} else {
					$stmt = $kname . "= " . formatString($kvalue);
				}
				break;
			}
		}
		
		$strSQL = "DELETE FROM " . $tableName . " WHERE " . $stmt;
		$recordset = mysql_query($strSQL);
		
	}
	
	// ----- process "insert" nodes -----	
	$nodes = $dom->getElementsByTagName("insert");
	
	foreach ($nodes as $node) {
		$operationId = $node->getAttribute("id");
		$names = "";
		$values = "";
		
		$fields = $node->getElementsByTagName("field");		
		// -- find key --
		foreach ($fields as $field) {
			if ($field->getAttribute("key") == "true") {
				$kname = $field->getAttribute("name");
				//
				if ($names == "") {
					$names = $kname;
					$values = "''";
				} else {
					$names = $names . "," . $kname;
					$values = $values . "," . "''";
				}
				
				break;
			}
		}
		

		// -- build names and values --
		foreach ($fields as $field) {
			if ($field->getAttribute("key") == "false") {
				$fname = $field->getAttribute("name");
				$ftype = $field->getAttribute("type");
				$fvalue = $field->getAttribute("newValue");

				// -- check NullValue --
				if ($fvalue == $nullValue) {
					$fvalue = "NULL";
				} else {
					// -- format value --
					if ($ftype == "Integer" || $ftype == "Number") {
						// Rien
					} else {
						$fvalue = formatString($fvalue);
					}
				}
				//
				if ($names == "") {
					$names = $fname;
					$values = $fvalue;
				} else {
					$names = $names . "," . $fname;
					$values = $values . "," . $fvalue;
				}				
				
			}
		}
		// Build insert Statement
		$strSQL = "INSERT INTO " . $tableName . " (" .  $names . ") VALUES (" . $values . ")"; 
		$recordset = mysql_query($strSQL);
		$newId = mysql_insert_id();
		
		// -- append result doc for newId --
		$roperationNode = new DOMElement("operation", "");
		$resultRootNode->appendChild($roperationNode);
		$roperationNode->setAttribute("op", "update");
		$roperationNode->setAttribute("id", $operationId);
		
		$rfieldNode = new DOMElement("field", "");
		$roperationNode->appendChild($rfieldNode);	
		$rfieldNode->setAttribute("name", $kname);
		$rfieldNode->setAttribute("curValue", $newId);
		
	}

	mysql_close();
	
	// print result packet
	print $resultdoc->saveXML();

?>


